#include "settings.h"
#include "suarttx.h"
#include "onwire.h"
#include <avr/power.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <util/delay.h>
#include<stdio.h> 

char s[100];

int main(void)
{
  clock_prescale_set(clock_div_1);              // 8MHz
  sei();
  sputs("Start\n\r", TX_SRAM);
  while(1)
  {
    onwi_measure();
    while (onwi_busy());
    onwi_read_temp(20);                         // 2s
    while (onwi_busy());
    onwi_read_rom();
    while (onwi_busy());
    sprintf(s, "ROM: %02X.%02X.%02X.%02X_%02X.%02X.%02X.%02X    CRC: %02X\n\r",
      onwi.buf[0], onwi.buf[1], onwi.buf[2], onwi.buf[3], 
      onwi.buf[4], onwi.buf[5], onwi.buf[6], onwi.buf[7], 
      onwi_crc(8));
    sputs(s, TX_SRAM);      
    onwi_read_temp(0);
    while (onwi_busy());
    sprintf(s, "TMP: %02X.%02X_%02X.%02X.%02X.%02X_%02X.%02X.%02X CRC: %02X\n\r",
      onwi.buf[0], onwi.buf[1], onwi.buf[2], onwi.buf[3], 
      onwi.buf[4], onwi.buf[5], onwi.buf[6], onwi.buf[7],
      onwi.buf[8], onwi_crc(9));
    sputs(s, TX_SRAM);
    sprintf(s, "TMP: %6.2f\n\r", (onwi.buf[0] | onwi.buf[1]<<8) / 16.0);
    sputs(s, TX_SRAM);
  }
}
